Description

Explore memory layout without several layers of pointers, but store
everything (refCount,size,data) in one memory block. Compare std::string implementation.
Possible benefits (?):
    -  Faster allocation/deallocation
    -  Faster dereferencing
    -  Smaller memory footprint (in particular for small vectors)
    -  Maybe better caching behavior (memory that's used together belongs together!)

Drawbacks:
very ugly!

History
#1 - 06/21/2012 03:40 PM - M. Rolf
- Status changed from New to In Progress
- % Done changed from 0 to 40

#2 - 06/21/2012 03:44 PM - M. Rolf

Benchmark results for first implementation:

Benchsuite [MathVectorCreate]
    Performing each case 10000000 times with operation-size 10

    Benchcase [MathVectorCreate:Create]
            Operations per second:    9.71064e+06

    Benchcase [MathVectorCreate:CreateCopyModify]
            Operations per second:    4.81884e+06

Compared to previous implementation:

Benchsuite [MathVectorCreate]
    Performing each case 10000000 times with operation-size 10

    Benchcase [MathVectorCreate:Create]
            Operations per second:    5.36829e+06

    Benchcase [MathVectorCreate:CreateCopyModify]
            Operations per second:    2.64776e+06
Compared to Eigen2:

Benchsuite [MathVectorCreate]
    Performing each case 10000000 times with operation-size 10

    Benchcase [MathVectorCreate:Create:Eigen]
            Operations per second:    9.52886e+06

    Benchcase [MathVectorCreate:CreateCopyModify:Eigen]
            Operations per second:    3.77345e+06

#3 - 06/27/2012 03:13 PM - M. Rolf
- % Done changed from 40 to 60

#4 - 10/02/2012 04:40 PM - M. Rolf
- % Done changed from 60 to 80

#5 - 01/15/2013 05:15 PM - M. Rolf
- Status changed from In Progress to Resolved
- % Done changed from 80 to 100
